<?php if (!defined('PmWiki')) exit();
/*  PMWikiEnhancedFeed, enhanced feed capabilities for PmWiki.
    Copyright (C) 2007 Jeremy Austin-Bardo <tjaustinbardo@gmail.com>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    MODULE: PMWikiEnhancedFeed
    USAGE: 
*/
$RecipeInfo['EnhancedFeeds']['Version'] = '2007-07-20';
// Set Default Anchor Block
SDV($BE_PageSection,"/\[\[#blog\]\](.*?)\[\[#blogend\]\]/esi");

function FeedTextSection($pagename, &$page, $tag) {
    // Set <description> to page section extracted
    global $BE_PageSection;
    $page = ReadPage($pagename);
    // Prepare output from first marked section
    preg_match($BE_PageSection,$page['text'],$entry);
    $content = MarkupToHTML($pagename, $entry['0']);
    return "<$tag><![CDATA[$content]]></$tag>";
}

function FeedTextPage($pagename, &$page, $tag) {
    // Set <description> to page content
    global $BE_PageSection;
    $page = ReadPage($pagename);
    // Prepare output from entire page
    $content = MarkupToHTML($pagename, $page['text']);
    return "<$tag><![CDATA[$content]]></$tag>";
}

function FeedCategory($pagename, &$page, $tag) {
    // Set <category> to native PMWiki categories found on page
    $page = ReadPage($pagename);
    preg_match_all("/\[\[!(.*?)\]\]/",$page['text'],$category);
    foreach ($category[1] as $element) $content .= "<$tag>".$element."</$tag>\n";
    return $content;
 }  
